# vim: set ts=4 sw=4 sts=0 :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
# board size: w=152, h=170
# blacket size: w=24, h=valiable 
from CBoardSpace import CBoardSpace
import PIL.Image
import os
_path = os.path.join(os.path.dirname(__file__), 'img')
_pic_dir = os.path.join(_path, '14x13g')
_ban_dir = os.path.join(_path, 'board18x16g')
_dig_dir = os.path.join(_path, 'dig11x7g')

c_blacks = {
	'K': PIL.Image.open(os.path.join(_pic_dir, 'B10.png'), 'r'),
	'R': PIL.Image.open(os.path.join(_pic_dir, 'B30.png'), 'r'),
	'B': PIL.Image.open(os.path.join(_pic_dir, 'B40.png'), 'r'),
	'G': PIL.Image.open(os.path.join(_pic_dir, 'B50.png'), 'r'),
	'S': PIL.Image.open(os.path.join(_pic_dir, 'B60.png'), 'r'),
	'N': PIL.Image.open(os.path.join(_pic_dir, 'B70.png'), 'r'),
	'L': PIL.Image.open(os.path.join(_pic_dir, 'B80.png'), 'r'),
	'P': PIL.Image.open(os.path.join(_pic_dir, 'B90.png'), 'r'),
	'+K': PIL.Image.open(os.path.join(_pic_dir, 'B10.png'), 'r'),
	'+R': PIL.Image.open(os.path.join(_pic_dir, 'B31.png'), 'r'),
	'+B': PIL.Image.open(os.path.join(_pic_dir, 'B41.png'), 'r'),
	'+G': PIL.Image.open(os.path.join(_pic_dir, 'B50.png'), 'r'),
	'+S': PIL.Image.open(os.path.join(_pic_dir, 'B61.png'), 'r'),
	'+N': PIL.Image.open(os.path.join(_pic_dir, 'B71.png'), 'r'),
	'+L': PIL.Image.open(os.path.join(_pic_dir, 'B81.png'), 'r'),
	'+P': PIL.Image.open(os.path.join(_pic_dir, 'B91.png'), 'r'),
}
c_whites = {
	'K': PIL.Image.open(os.path.join(_pic_dir, 'W20.png'), 'r'),
	'R': PIL.Image.open(os.path.join(_pic_dir, 'W30.png'), 'r'),
	'B': PIL.Image.open(os.path.join(_pic_dir, 'W40.png'), 'r'),
	'G': PIL.Image.open(os.path.join(_pic_dir, 'W50.png'), 'r'),
	'S': PIL.Image.open(os.path.join(_pic_dir, 'W60.png'), 'r'),
	'N': PIL.Image.open(os.path.join(_pic_dir, 'W70.png'), 'r'),
	'L': PIL.Image.open(os.path.join(_pic_dir, 'W80.png'), 'r'),
	'P': PIL.Image.open(os.path.join(_pic_dir, 'W90.png'), 'r'),
	'+K': PIL.Image.open(os.path.join(_pic_dir, 'W20.png'), 'r'),
	'+R': PIL.Image.open(os.path.join(_pic_dir, 'W31.png'), 'r'),
	'+B': PIL.Image.open(os.path.join(_pic_dir, 'W41.png'), 'r'),
	'+G': PIL.Image.open(os.path.join(_pic_dir, 'W50.png'), 'r'),
	'+S': PIL.Image.open(os.path.join(_pic_dir, 'W61.png'), 'r'),
	'+N': PIL.Image.open(os.path.join(_pic_dir, 'W71.png'), 'r'),
	'+L': PIL.Image.open(os.path.join(_pic_dir, 'W81.png'), 'r'),
	'+P': PIL.Image.open(os.path.join(_pic_dir, 'W91.png'), 'r'),
}
_black_top = PIL.Image.open(os.path.join(_ban_dir, 'black1.png'), 'r')
_white_top = PIL.Image.open(os.path.join(_ban_dir, 'white1.png'), 'r')
_digit = (
PIL.Image.open(os.path.join(_dig_dir, '0.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '1.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '2.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '3.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '4.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '5.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '6.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '7.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '8.png'), 'r'),
PIL.Image.open(os.path.join(_dig_dir, '9.png'), 'r'),
)

class CxBoard(CBoardSpace):
	width = 152
	height = 170
	def __init__(self):
		CBoardSpace.__init__(self, xo=4, yo=4, xs=16, ys=18, b=c_blacks, w=c_whites)
		self.imgpath = os.path.join(_ban_dir, 'board.png')
		self.hilight = lambda i: i * 0.8
		self.symbol1 = _black_top
		self.symbol2 = _white_top

	def pasteOnBoard(self, base, img, x=0, y=0):
		""" method to called by board (supper) class """
		base.paste(img, (x + 2, y + 3))

	def pickupTarget(self, space, pos, id):
		pick = None
		if id == 0:
			pos = CBoardSpace.getColRow(self, pos)
			s = space.what(pos)
			if s:
				pick = (s[0], s[1:], pos)
		elif id == 1 or id == 2:
			list = space.getFrees(id)
			poslist = self.__getPosition(list)
			y = pos[1]
			if id == 2:
				y = self.height - self.ys - y
			for c in poslist:
				h = c[3]
				if y >= h and y < h + self.ys:
					pick = (str(id), c[0], None)
					break
		return pick

	def pastePickImage(self, base, pick):
		bw = pick[0]
		pc = pick[1]
		pos = pick[2]
		x, y = self.getAbsPosition(pos)
		box = base.crop((x, y, x + self.xs, y + self.ys))
		box = box.point(self.hilight)
		base.paste(box, (x, y))

	def getBlacketImg(self, space, bw=1, pick=None):
		img = None
		if bw == 1:
			list = space.getFrees(1)
			img = self.__getBlacket(list)
			img.paste(_black_top, (3, 3))
			if pick and not pick[2] and pick[0] == '1':
				self.__markTarget(img, list, pick[1])
		elif bw == 2:
			list = space.getFrees(2)
			img = self.__getBlacket(list)
			img.paste(_white_top, (3, 3))
			if pick and not pick[2] and pick[0] == '2':
				self.__markTarget(img, list, pick[1])
			img = img.rotate(180)
		return img

	def __markTarget(self, img, list, s):
		poslist = self.__getPosition(list)
		for c in poslist:
			x = c[2]
			y = c[3]
			if s == c[0]:
				box = img.crop((x, y, x + self.xs, y + self.ys - 2))
				box = box.point(self.hilight)
				img.paste(box, (x, y))
				break

	def __getPosition(self, list):
		poslist = []
		cnt = 0
		for s in list:
			cnt += s[1]
		x = 3
		y = 20
		if cnt < 9:
			for s in list:
				n = s[1]
				for i in range(n):
					poslist.append((s[0], 1, x, y))
					y += 15
		else:
			for s in list:
				poslist.append((s[0], s[1], x, y))
				y += 15
		return poslist

	def __getBlacket(self, list):
		poslist = self.__getPosition(list)
		img = PIL.Image.new('RGB',(24, 145),(255,255,255))
		for c in poslist:
			box = c_blacks[c[0]]
			n = c[1]
			x = c[2]
			y = c[3]
			img.paste(box, (x, y))
			if n >= 10:
				box = _digit[n % 10]
				img.paste(box, (x + 14, y + 6))
				box = _digit[n / 10]
				img.paste(box, (x + 9, y + 6))
			elif n > 1:
				box = _digit[n]
				img.paste(box, (x + 14, y + 6))
		return img

